"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _execute_strategy = _interopRequireDefault(require("./execute_strategy"));

var _wrap_auth_request = _interopRequireDefault(require("./wrap_auth_request"));

var _send_auth_response = _interopRequireDefault(require("./send_auth_response"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const apiHandlerConstructor = ({
  strategyHash,
  options
}, {
  createStrategy,
  callback
}) => async (req, res) => {
  try {
    const authRequest = (0, _wrap_auth_request.default)(req);
    const authResponse = await (0, _execute_strategy.default)(authRequest, createStrategy, options, strategyHash, callback);
    const noredirect = authRequest.body && authRequest.body.noredirect && String(authRequest.body.noredirect) === 'true' || authRequest.query && authRequest.query.noredirect && String(authRequest.query.noredirect) === 'true';
    await (0, _send_auth_response.default)(authResponse, res, authRequest.resolve.rootPath, noredirect);
  } catch (error) {
    res.status(504);
    const outError = error != null && error.stack != null ? `${error.stack}` : `Unknown error ${error}`;
    res.end(outError);
  }
};

var _default = apiHandlerConstructor;
exports.default = _default;
//# sourceMappingURL=api_handler_constructor.js.map