"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _wrap_auth_request = _interopRequireDefault(require("./wrap_auth_request"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const logoutApiHandler = async (req, res) => {
  try {
    const authRequest = (0, _wrap_auth_request.default)(req);
    const {
      jwtCookie,
      rootPath
    } = authRequest.resolve;
    res.cookie(jwtCookie.name, '', {
      expires: new Date(0),
      path: `/${rootPath}`
    });
    res.setHeader('Authorization', '');
    res.setHeader('X-JWT', '');
    const noredirect = authRequest.body && authRequest.body.noredirect && String(authRequest.body.noredirect) === 'true' || authRequest.query && authRequest.query.noredirect && String(authRequest.query.noredirect) === 'true';

    if (noredirect) {
      res.status(200);
      res.end('OK');
      return;
    }

    const referer = authRequest.headers['referer'];

    if (referer != null) {
      res.redirect(referer);
      return;
    }

    res.redirect(`/${rootPath}`);
  } catch (error) {
    res.status(504);
    const outError = error != null && error.stack != null ? `${error.stack}` : `Unknown error ${error}`;
    res.end(outError);
  }
};

var _default = logoutApiHandler;
exports.default = _default;
//# sourceMappingURL=logout_api_handler.js.map